#include  "mk7a21p.inc"  ;ĵ"mk7a21p.inc"ļ
;---------------------------------------------------------------------
;оƬͺţmk7a21p 
;---------------------------------------------------------------------
;üĴ˵CONFIG 
;1-----------FOSC=INRC     ;LS,NS,HS,RC,INRCʱӣ 
       ;INRC&LS,INRC&NS,INRC&HS   
;2-----------CPT=OFF    ;ON,OFF    
;3-----------WDTE=Disable   ;Enable,Disable 
;4-----------LV=2.3V    ;4V,2.3V,Don't use 
;5-----------RST_DEF=...input...  ;...input...,...reset... 
;6-----------EXT_CLK=...IO...  ;...IO...,...timer sourse... 
;--------------------------------------------------------------------- 
a_buf    	equ   		0x40 
status_buf   	equ   		0x41 
dat_0          	equ        	0x42 
dat_1          	equ        	0x43 
sec_r         	equ         	0x44 
tm_r            equ        	0x45 
;--------------------------------------------------------------------- 
             	org          	0x000  		;mk7a21pĸλַ 
                lgoto        	main   		;ת 
             	org       	0x004  		;mk7a21pжַ 
             	lgoto        	int   		;תжϳ 
;--------------------------------------------------------------------- 
    		org   		0x010 
int 
    		movam  		a_buf 
    		swap   		status,a
    		movam  		status_buf  	;ֳ 
    		;-----------------------------------------------------
      btsc   		irqf,tm1f
		lgoto   	int_tm1  	;TM1йصжϷ 
    		btsc   		irqf,tm2f 
    		lgoto   	int_tm2  	;TM2йصжϷ 
    		btsc   		irqf,tm3f 
    		lgoto   	int_tm3  	;TM3йصжϷ 
    		btsc   		irqf,paf 
    		lgoto   	int_pa  	;PortAжϷ 
    		btsc   		irqf,adcf 
    		lgoto   	int_adc  	;ADתжϷ 
;---------------------------------------------------------------------
int_end 
    		swap   		status_buf,a 
    		movam  		status   
    		swap   		a_buf,m 
    		swap   		a_buf,a  	;ֳָ 
    		reti 
;--------------------------------------------------------------------- 
int_tm1 
    		bc   		irqf,tm1f 
		;-----------------------------------------------------
      		;TM1жϷ 
      		;----------------------------------------------------- 
    		lgoto   	int_end 
;--------------------------------------------------------------------- 
int_tm2 
    		bc   		irqf,tm2f 
      		;-----------------------------------------------------
    		;TM2жϷ 
 		;----------------------------------------------------- 
    		lgoto   	int_end 
;---------------------------------------------------------------------
int_tm3 
    		bc   		irqf,tm3f 
 		;----------------------------------------------------- 
    		;TM3жϷ 
      		;----------------------------------------------------- 
    		lgoto   	int_end  
;--------------------------------------------------------------------- 
int_pa 
    		bc   		irqf,paf 
      		;----------------------------------------------------- 
    		;PortAжϷ 
      		;----------------------------------------------------- 
    		lgoto   	int_end  
;--------------------------------------------------------------------- 
int_adc 
    		bc   		irqf,adcf 
      		;----------------------------------------------------- 
    		;adcжϷ 
    		mov   		ad_dat,a 
    		movam  		pa_dat 
    		clr         	pc_dat 
    		btsc        	sec_r,0 
    		bs           	pc_dat,0 
    		btsc        	sec_r,1 
    		bs           	pc_dat,2 
    		btsc        	sec_r,2 
    		bs         	pc_dat,3 
      		;----------------------------------------------------- 
    		lgoto   	int_end     
;---------------------------------------------------------------------
main                                                                                        
              	movla  		b'00000000'  
                movam  		sys_ctl  	;ʱģʽʱЧ 
                       				;˫ʱģʽʱ:Bit7---ϵͳʱѡ 
                       				;˫ʱģʽʱ:Bit1---ڲRC񵴿 
                       				;˫ʱģʽʱ:Bit0---ⲿ񵴿 
            	;-----------------------------------------------------
             	movla  		b'10000011'  
              	movam  		wdt_ctl  	;WDTʹܼԤƵΪ1:8          
               	;----------------------------------------------------- 
            	movla  		b'00000000' 
              	movam  		pa_dir   	;PA0-7 
               	movla  		b'00000000' 
                movam  		pa_dat  	;PA0-7״̬ 
              	movla  		b'00000000' 
             	movam  		pa_plu   	;PA0-7ֹ 
              	movla  		b'00000000' 
                movam  		pa_inte   	;PA0-7ѽֹ(ⲿжϽֹ)
               	;-----------------------------------------------------
              	movla  		b'11111111' 
              	movam  		pb_dir   	;PB0-3 
              	movla  		b'11110000' 
              	movam  		pb_dat  	;PB0-3״̬ 
              	movla  		b'11111111' 
                movam  		pb_plu   	;PB0-3ʹ 
              	;-----------------------------------------------------
                movla  		b'11110000' 
             	movam  		pc_dir   	;PC0,2,3,PC1ֻΪ 
              	movla  		b'11110000' 
            	movam  		pc_dat  	;PC0-3״̬ 
                movla  		b'11110000' 
                movam  		pc_plu   	;PC0-3ֹ 
              	;----------------------------------------------------- 
             	movla         	b'01100010' 	;ΪTMR1ĳʼ 
              	movam       	tm1_ctl1       	;TM1׽ģʽ,ԤƵ1:4 
             	movla        	b'00000000' 
              	movam       	tm1_ctl2  	;Bit7:ȽϼԶʹ 
             	;----------------------------------------------------- 
            	mov          	clr_cnt,m  	;дĴȽϼ 
             	;----------------------------------------------------- 
                movla         	0x50 
              	movam      	tm1l_la 
              	movla        	0xc3 
              	movam        	tm1h_la 
              	;-----------------------------------------------------
              	movla       	b'01100010' 	;ΪTMR2ĳʼ 
               	movam     	tm2_ctl1 
              	movla         	b'01000010' 
              	movam    	tm2_ctl2  	;Bit7:ģʽѡ/Bit6:PWMʼ״̬ 
                       				;Bit5:IOTO_E/Bit3-0:PWMԤƵ 
              	movla        	.200 
              	movam       	tm2_la 
              	;-----------------------------------------------------
              	movla         	b'01100010' 	;ΪTMR3ĳʼ 
             	movam        	tm3_ctl
              	movla        	.100 
             	movam        	tm3_la 
             	;----------------------------------------------------- 
             	movla        	b'00000000' 	;ADCĳʼ 
              	movam  		ad_ctl1  	;Bit7:adcʹ/Bit5:ģʽ/Bit1-0ͨѡ 
              	movla       	b'00000001' 
                movam  		ad_ctl2  	;Bit7:ȽϽ/Bit1-0:adcʱӱƵ 
               	movla       	b'00000100' 
              	movam  		ad_ctl3  	;Bit3-0:PB0-3ùܽŵѡ,ADC 
             	movla        	.0 
                movam  		ad_dat   
             	;----------------------------------------------------- 
              	movla         	b'11000000' 	;ж 
                movam       	irqm   		;Bit1:TM1/Bit2:TM2/Bit3:TM3 
                       				;Bit4:PA/Bit6:ADC/Bit7:жʹBit 
              	clr         	irqf 
              	;-----------------------------------------------------
              	bs          	tm1_ctl1,7  	;tmr1 
             	;bs           	tm2_ctl1,7 
            	;bs           	tm3_ctl1,7 
              	;----------------------------------------------------- 
              	clr           	sec_r 
;--------------------------------------------------------------------- 
loop 
    		btss   		irqf,tm1f 
    		lgoto   	$-1 
    		bc   		irqf,tm1f 
      		;-----------------------------------------------------
    		inc   		tm_r,m 
    		movla  		.50 
    		xor   		tm_r,a 
    		btss   		status,z 
    		lgoto   	loop 
    		clr   		tm_r 
      		;-----------------------------------------------------
             	clr          	pa_dat 
            	clr          	pc_dat 
      		;----------------------------------------------------- 
    		inc   		sec_r,m 
    		movla  		.4 
    		sub   		sec_r,a 
    		btsc   		status,c 
    		clr   		sec_r 
              	;----------------------------------------------------- 
              	movla        	b'00000111' 
              	movam      	tab_bnk 
              	tabrdl       	sec_r 
    		movam  		ad_ctl1  	;ݲѯֵ,ѡҪadתͨ 
      		;----------------------------------------------------- 
    		lgoto   	loop 
		;-----------------------------------------------------
              	org        	0x700 
             	dw     		0080h 
              	dw           	0081h 
             	dw           	0082h 
             	dw          	0083h 
;---------------------------------------------------------------------
              	end 